# Notes

- [Notes](#notes)
  - [闭包](#闭包)
    - [定义](#定义)
    - [不能推导两次的例子](#不能推导两次的例子)
    - [捕捉环境中的变量](#捕捉环境中的变量)
    - [泛型闭包](#泛型闭包)

## 闭包
### 定义
```
let add_one_v2 =|x :u32 |->u32{x+1};
let add_one_v3 =x{x +1};
let add_one_V4=|x|x+1;
```
### 不能推导两次的例子
```
let example_ closure = | x | x;
Let S = example_ closure(String: :from("hello")) ;
println!("s = {}",s) ;
// Let n = example_ closure(5) ;
Let n = exampLe_ closure(5.to_ string());
println! ("n = {}",n) ;
```
### 捕捉环境中的变量
```
leti=18
let exe =
|x| {x+i};
let r = exe(5) ;
println!("r = {}" ,r);
```
### 泛型闭包
- 实现一个缓存，只处理第一次传入的值并保持
```
struct Cacher<T>
    where T: Fn(u32) -> u32
{
    calcuation: T,
value: Option<u32>,
}
impl<T> Cacher<T>
    where T: Fn(u32) -> u32
{
    fn new(calcuation: T) -> Cacher<T> {
        Cacher {
            calcuation,
            value:None,
        }
    }
    fn value(&mut self,arg:u32)->{
        match self.value{
            Some(v)=>v,
            None=>{
                let v=(self.calcuation)(arg);
                self.value =Some(v);
                v
            },
        }
    }
}

fn main() {
    let mut c = Cacher::new(|x| x+1);
    let v1 =c.value(1);
    println!("v1={}",v1);
    println! ("Hello, world!");
}
```
