// 5.最长回文子串
// 给你一个字符串 s，找到 s 中最长的回文子串。
// https://leetcode-cn.com/problems/longest-palindromic-substring

// Rust实现
impl Solution {
    pub fn longest_palindrome(s: String) -> String {
        let mut ns = Vec::with_capacity(s.len() << 1 + 1);
        ns.push('#');
        s.chars().for_each(|x| {
            ns.push(x);
            ns.push('#');
        });

        let (mut start, mut end) = (0, 0);
        let mut arm_len = vec![0usize; ns.len()];
        let (mut right, mut mid) = (0, 0);

        for i in (0..ns.len()) {
            let min_arm_len;
            if right > i {
                let index = mid * 2 - i;
                min_arm_len = arm_len[index].min(right - i);
            } else {
                min_arm_len = 0;
            }

            let cur_arm_len = Solution::expand(&ns, i - min_arm_len, i + min_arm_len);

            arm_len[i] = cur_arm_len;
            if (i + cur_arm_len > right) {
                mid = i;
                right = i + cur_arm_len;
            }
            if (cur_arm_len * 2 + 1 > end - start) {
                start = i - cur_arm_len;
                end = i + cur_arm_len;
            }

            if (i + (end - start) / 2 >= ns.len()) {
                break;
            }
        }

        return String::from(&s[start / 2..end / 2]);
    }

    fn expand(s: &Vec<char>, left: usize, right: usize) -> usize {
        let mut left = left as i32;
        let mut right = right;
        while left >= 0 && right < s.len() && s[left as usize] == s[right] {
            left -= 1;
            right += 1;
        }
        return (right as i32 - left - 2) as usize / 2;
    }
}
//参考https://blog.csdn.net/leyi520/article/details/117026577

// Java实现
// class Solution {
//     public String longestPalindrome(String s) {
//     int start = 0, end = 0;
//     for (int i = 0; i < s.length(); i++) {
//         int len1 = expandAroundCenter(s, i, i);
//         int len2 = expandAroundCenter(s, i, i + 1);
//         int len = Math.max(len1, len2);
//         if (len > end - start) {
//             start = i - (len - 1) / 2;
//             end = i + len / 2;
//         }
//     }
//     return s.substring(start, end + 1);
// }

// private int expandAroundCenter(String s, int left, int right) {
//     int L = left, R = right;
//     while (L >= 0 && R < s.length() && s.charAt(L) == s.charAt(R)) {
//         L--;
//         R++;
//     }
//     return R - L - 1;
//     }
// }
