// 12. 整数转罗马数字
// 罗马数字包含以下七种字符： I， V， X， L，C，D 和 M。
// 字符          数值
// I             1
// V             5
// X             10
// L             50
// C             100
// D             500
// M             1000
// 例如， 罗马数字 2 写做 II ，即为两个并列的 1。12 写做 XII ，即为 X + II 。 27 写做  XXVII, 即为 XX + V + II 。
// 通常情况下，罗马数字中小的数字在大的数字的右边。但也存在特例，例如 4 不写做 IIII，而是 IV。数字 1 在数字 5 的左边，所表示的数等于大数 5 减小数 1 得到的数值 4 。同样地，数字 9 表示为 IX。这个特殊的规则只适用于以下六种情况：
// I 可以放在 V (5) 和 X (10) 的左边，来表示 4 和 9。
// X 可以放在 L (50) 和 C (100) 的左边，来表示 40 和 90。 
// C 可以放在 D (500) 和 M (1000) 的左边，来表示 400 和 900。
// 给你一个整数，将其转为罗马数字。

//Rust实现
impl Solution {
    pub fn int_to_roman(mut num: i32) -> String {
        let cdr = ['I', 'V', 'X', 'L', 'C', 'D', 'M', '-', '-'];
        let mut res = String::new();
        for i in 0..4 {
            let left = num as usize % 10;
            num /= 10;
            if left <= 3 {
                for j in 0..left {
                    res.push(cdr[i * 2]);
                }
            } else if left <= 4 {
                res.push(cdr[i * 2 + 1]);
                res.push(cdr[i * 2]);
            } else if left <= 8 {
                for j in 5..left {
                    res.push(cdr[i * 2]);
                }
                res.push(cdr[i * 2 + 1]);
            } else {
                res.push(cdr[i * 2 + 2]);
                res.push(cdr[i * 2]);
            }
            if num == 0 {
                break;
            }
        }
        res.chars().rev().collect()
    }
}

//C++实现
// class Solution {
// public:
//     string intToRoman(int num) {
//         const string cdr = "IVXLCDM--";
//         string res;
//         for (int i = 0; i < 4 && num > 0; ++i) {
//             int left = num % 10;
//             num /= 10;
//             if (left <= 3)
//                 res += string(left, cdr[i * 2]);
//             else if (left <= 4) {
//                 res += cdr[i * 2 + 1];
//                 res += cdr[i * 2];
//             } else if (left <= 8)
//                 res += string(left - 5, cdr[i * 2]) + cdr[i * 2 + 1];
//             else {
//                 res += cdr[i * 2 + 2];
//                 res += cdr[i * 2];
//             }
//         }
//         reverse(res.begin(), res.end());
//         return res;
//     }
// }; 