// 28. 实现 strStr()
// 实现 strStr() 函数。
// 给你两个字符串 haystack 和 needle ，请你在 haystack 字符串中找出 needle 字符串出现的第一个位置（下标从 0 开始）。如果不存在，则返回  -1 。
// 说明：
// 当 needle 是空字符串时，我们应当返回什么值呢？这是一个在面试中很好的问题。
// 对于本题而言，当 needle 是空字符串时我们应当返回 0 。这与 C 语言的 strstr() 以及 Java 的 indexOf() 定义相符。
//https://leetcode-cn.com/problems/implement-strstr

//Rust实现
impl Solution {
   pub fn str_str(haystack: String, needle: String) -> i32 {
       if needle.len() == 0 {
           return 0;
       }
       let mut j: i32 = -1;
       let next: Vec<i32> = Solution::get_next(needle.as_bytes());
       let (haystack, needle) = (haystack.as_bytes(), needle.as_bytes());
       for i in 0..haystack.len() {
           while j >= 0 && haystack[i] != needle[(j + 1) as usize] {
               j = next[j as usize];
           }
           if haystack[i] == needle[(j + 1) as usize] {
               j += 1;
           }
           if j == (needle.len() - 1) as i32 {
               return (i - needle.len() + 1) as i32;
           }
       }
       -1
   }

   pub fn get_next(s: &[u8]) -> Vec<i32> {
       let mut j: i32 = -1;
       let mut next = vec![0; s.len()];
       next[0] = j;
       for i in 1..s.len() {
           while j >= 0 && s[i] != s[(j + 1) as usize] {
               j = next[j as usize];
           }
           if s[i] == s[(j + 1) as usize] {
               j += 1;
           }
           next[i] = j;
       }
       next
   }
}


//C++实现
// class Solution {
// public:
//     int strStr(string haystack, string needle) {
//         int m = haystack.size(), n = needle.size();
//         if(!n)
//             return 0;
//         int indx = 0;
//         while(indx <= m - n){
//             int i = 0, j = n - 1;
//             int l = indx, r = indx + n - 1;
//             while(haystack[l++] == needle[i++] && haystack[r--] == needle[j--]){
//                 if(l > r && i > j)
//                     return indx;
//             }
//             indx++;
//         }
//         return -1;
//     }
// };
