// 扰乱字符串
// 使用下面描述的算法可以扰乱字符串 s 得到字符串 t ：
// 如果字符串的长度为 1 ，算法停止
// 如果字符串的长度 > 1 ，执行下述步骤：
// 在一个随机下标处将字符串分割成两个非空的子字符串。即，如果已知字符串 s ，则可以将其分成两个子字符串 x 和 y ，且满足 s = x + y 。
// 随机 决定是要「交换两个子字符串」还是要「保持这两个子字符串的顺序不变」。即，在执行这一步骤之后，s 可能是 s = x + y 或者 s = y + x 。
// 在 x 和 y 这两个子字符串上继续从步骤 1 开始递归执行此算法。
// 给你两个 长度相等 的字符串 s1 和 s2，判断 s2 是否是 s1 的扰乱字符串。如果是，返回 true ；否则，返回 false 。
// https://leetcode-cn.com/problems/scramble-string

//Rust实现
impl Solution {
    pub fn is_scramble(s1: String, s2: String) -> bool {
        if (s1.len() != s2.len()) {
           return false;
       }
       let n = s1.len();
       let mut dp = vec![vec![vec![false; n + 1]; n]; n];
       for i in 0..n {
           for j in 0..n {
               dp[i][j][1] = (s1.chars().nth(i) == s2.chars().nth(j));
           }
       }
       for k in 2..=n {
           for i in 0..=(n - k) {
               for j in 0..=(n - k) {
                   for ck in 1..k {
                       dp[i][j][k] |= (
                           (dp[i][j][ck] && dp[i + ck][j + ck][k - ck]) ||
                           (dp[i][j + k - ck][ck] && dp[i + ck][j][k - ck])
                       );
                   }
               }
           }
       }
       dp[0][0][n]
   }
}

//C++实现
// class Solution {
// public:
//    bool isScramble(string s, string t) {
//        if (s.length() != t.length()) return false;
//        int n = s.length();
//        vector<vector<vector<int>>> dp(n, vector<vector<int>>(n, vector<int>(n + 1, 0)));
//        for (int i = 0; i < n; ++ i)
//            for (int j = 0; j < n; ++ j)
//                dp[i][j][1] = s[i] == t[j];
//        for (int k = 2; k <= n; ++ k){
//            for (int i = 0; i + k <= n; ++ i){
//                for (int j = 0; j + k <= n; ++ j){
//                    for (int ck = 1; ck < k; ++ ck){
//                        dp[i][j][k] |= (
//                            (dp[i][j][ck] && dp[i + ck][j + ck][k - ck]) ||
//                            (dp[i][j + k - ck][ck] && dp[i + ck][j][k - ck])
//                        );
//                    }
//                }
//            }
//        }
//        return dp[0][0][n];
//    }
// };